<?php
/**
 * Plugin Name: LitRes Plugin
 * Plugin URI: http://www.litres.ru/
 * Description: Управление публикацией книг ЛитРес
 * Version: 4.0.2
 * Author: СИБИС Технологии
 * Author URI: http://erminesoft.ru/
 * License: GPL2
 **/

error_reporting(1); 
ini_set('display_errors', true);

add_action('admin_menu', 'litres_plugin_add_admin_pages');
add_action('wp_enqueue_scripts','litres_plugin_script');

//add_action( 'wp_ajax_book_publish', 'litres_plugin_book_publish' );

function litres_plugin_script() {
	wp_enqueue_script('jquery');
    wp_enqueue_script( 'ckeditor_js', plugins_url( '/js/ckeditor/ckeditor.js', __FILE__ ));
    wp_enqueue_script( 'litres_plugin_js', plugins_url( '/js/litres_plugin.js', __FILE__ ));
}

function litres_plugin_get_page($the_page_title) {
	$args=array(
		'name'           => $the_page_title,
		'post_type'      => 'post',
		'post_status'    => 'publish',
		'posts_per_page' => 1
	);
	$my_posts = get_posts( $args );
	if(count($my_posts) > 0)
		return $my_posts[0];
	return false;
}


function litres_plugin_del_book_page($book) {
	$the_page_title = litres_plugin_page_id($book->id);
	$the_page = litres_plugin_get_page($the_page_title);

    if ( $the_page && $the_page->ID ) {
		wp_delete_post( $the_page->ID, true );
	}
}

function litres_plugin_add_book_page($book) {

	$category = 1;
	if(isset($_POST["category"]))
		$category = $_POST["category"];
	 
	$the_page_title = litres_plugin_page_id($book->id);
	$the_page = litres_plugin_get_page($the_page_title);


    if ( $the_page && $the_page->ID ) {
		wp_delete_post( $the_page->ID, true );
	}


	$title = "\$book_title";
	$template = "<h2>\$authors</h2>\n".
	"<img src=\"\$book_cover_url\" alt=\"\$book_title\"/>\n<p>\$annotation</p>\n<p>".
	"\$price&nbsp;<a href=\"\$sample_url\">Читать фрагмент</a>&nbsp;<a href=\"\$purchase_url\">Купить книгу</a></p>";
	$tags = "\$genres, \$tags, \$sequences";

	if(file_exists(plugin_dir_path( __FILE__ )."litres_title"))
		$title = file_get_contents(plugin_dir_path( __FILE__ )."litres_title");
	if(file_exists(plugin_dir_path( __FILE__ )."litres_template"))
		$template = file_get_contents(plugin_dir_path( __FILE__ )."litres_template");
	if(file_exists(plugin_dir_path( __FILE__ )."litres_tags"))
		$tags = file_get_contents(plugin_dir_path( __FILE__ )."litres_tags");


    // Create post object
    $_p = array();
    $_p['post_title'] = litres_plugin_template($title,$book);
    $_p['post_name'] = $the_page_title;
    $_p['post_content'] = litres_plugin_template($template,$book);
    $_p['post_status'] = 'publish';
    $_p['post_type'] = 'post';
    $_p['comment_status'] = 'open';
    $_p['ping_status'] = 'closed';
    $_p['post_category'] = array($category); // the default is 1 - 'Uncatergorised'
	$_p['tags_input'] = preg_replace("/^,/","",preg_replace("/,$/","",trim(str_replace(" , "," ",litres_plugin_template($tags,$book)))));

    // Insert the post into the database
	return wp_insert_post( $_p );
}

function litres_plugin_categories_select() {
	$categories = "";
	$allcat = get_categories(array('orderby'=>'name','hide_empty'=>false));

	$got1 = false;
	foreach($allcat as $cat)
	{
		if(isset($cat->term_id))
			$categories.="<option value=\"".$cat->term_id."\"".($cat->term_id == 1 ? " selected" : "").">".$cat->name."</option>";
		if(isset($cat->term_id) && $cat->term_id == 1)
			$got1 = true;
	}
	if(!$got1)
		$categories="<option value=\"1\" selected>Без рубрики</option>".$categories;;
	return $categories;
}

class litres_catalitv2_request
{
	var $app = '728657049';
	var $time = "";
	var $sha="";
	var $sid="";
	var $requests = array();	

	function __construct()
	{
		$this->time = litres_plugin_catalitv2_time();
		$this->sha = litres_plugin_catalitv2_sha($this);
	}

	function add_request($command, $fields, $id = false)
	{
		$request = new litres_catalitv2_request_func();
		$request->func = $command;
		if(!$id)
			$id = $command;
		$request->id = $id;
		foreach($fields as $field=>$val)
		{
			$request->param->{$field} = $val;
		}
		$this->requests[count($this->requests)] = $request;
	}
}



class litres_catalitv2_request_func {
	var $func = "";
	var $id = "none";	
	var $param;

	function __construct()
	{
		$this->param = new litres_catalitv2_request_func_param();
	}
}

class litres_catalitv2_request_func_param {
}

                                                    
$litres_plugin_catalitv2_time_add = -1;
function litres_plugin_catalitv2_time()
{
	global $litres_plugin_catalitv2_time_add;
	$litres_plugin_catalitv2_time_add++;
	return date("Y-m-d\TH:i:sP",time()+$litres_plugin_catalitv2_time_add);
}

function litres_plugin_catalitv2_sha($request)
{
	$secret = 'WuEoh7THlIT0hTzxGGJ3yVvZkipscUJpIm0kj0tnKwCcmt4bRAv9mVp3XuRO5PXGGtDDLKfBMquxDQpWTJD595DqG9cXR4WEMpCNFBl4YdYn8q6PtKM6GrhxoQ60wVGa';
	return hash("sha256", $request->time.$secret, false);		
}

function litres_plugin_catalitv2_sid()
{
	if(file_exists(plugin_dir_path( __FILE__ )."litres_plugin_catalitv2_sid"))
		return(file_get_contents(plugin_dir_path( __FILE__ )."litres_plugin_catalitv2_sid"));
	
	$data = litres_plugin_catalitv2("w_create_sid", array("login"=>"Anonymous","pwd"=>"0","sid"=>""));
	if($data)
		$data = json_decode($data);

	$sid = false;
	if($data && isset($data->success) && $data->success)
	{
		$sid = $data->w_create_sid->sid;
		file_put_contents(plugin_dir_path( __FILE__ )."litres_plugin_catalitv2_sid",$sid);
	}
	return $sid;
}

function litres_plugin_catalitv2($command, $fields, $id = false)
{
	$out = false;
	$outdata = false;
	$data = new litres_catalitv2_request();

	$data->add_request($command, $fields, $id);

	if($command != "w_create_sid")
	{
		$sid = litres_plugin_catalitv2_sid();
		if(!$sid)
			return $out;
		$data->sid = $sid;
	}
	
	$jdata = json_encode($data);
	file_put_contents(plugin_dir_path( __FILE__ )."litres_plugin_request",$jdata);

	if( $curl = curl_init() ) 
	{
    	curl_setopt($curl, CURLOPT_URL, 'https://catalit.litres.ru/catalitv2');
    	curl_setopt($curl, CURLOPT_RETURNTRANSFER,true);
    	curl_setopt($curl, CURLOPT_POST, true);
    	curl_setopt($curl, CURLOPT_POSTFIELDS, "jdata=".urlencode($jdata));
		curl_setopt($curl, CURLOPT_CAINFO, plugin_dir_path( __FILE__ )."cacert.pem");
    	$outjson = curl_exec($curl);
		if($outjson)
		{
			$outdata = json_decode($outjson);
			$out = $outjson;
		}
		file_put_contents(plugin_dir_path( __FILE__ )."litres_plugin_response",$outjson);
    	curl_close($curl);
  	}

 	if($outdata && isset($outdata->success) && !$outdata->success && $outdata->error_code == 101000)
	{
		unlink(plugin_dir_path( __FILE__ )."litres_plugin_catalitv2_sid");
		return litres_plugin_catalitv2($command, $fields);
	}
	return $out;
}


function litres_plugin_page_id($id)
{
	return "litres_".$id;
}

function litres_plugin_add_admin_pages() {
	// Add a new submenu under Options:
    add_options_page('ЛитРес', 'ЛитРес', 8, __FILE__, 'litres_plugin_options_page');
}

function litres_plugin_options_page() {
	$action = "books";
	if(isset($_GET['action']))
		$action = $_GET['action'];
	if(isset($_POST['action']))
		$action = $_POST['action'];

	litres_plugin_script();

	//if($action == "book_publish")
	//	litres_plugin_book_publish();
	if($action == "books")
		litres_plugin_options_page1();
	if($action == "template")
		litres_plugin_options_page2();
	if($action == "settings")
		litres_plugin_options_page3();
}


function litres_plugin_template($template,$book)
{
	$lrkey = "";
	if(file_exists(plugin_dir_path( __FILE__ )."litres_key"))
		$lrkey = file_get_contents(plugin_dir_path( __FILE__ )."litres_key");

	$book->purchase_url = "//litres.ru/".$book->id."/?lfrom=".$lrkey;
	$book->sample_url = "//www.litres.ru/pages/quickread/?art=".$book->id."&lfrom=".$lrkey;

	foreach($book as $k=>$v)
	{
		$vv = str_replace("http://","//",$v);
		$vv = str_replace("https://","//",$vv);
		$template = str_replace("\$".$k,$vv,$template);
	}
	return $template;
}

$litres_plugin_url_base = "?page=";

function litres_plugin_url()
{
	global $litres_plugin_url_base;
	return $litres_plugin_url_base.plugin_basename(__FILE__);
}

function litres_plugin_options_pageheader($action)
{
	echo "<h2>ЛитРес</h2>";	

	echo "<h3 style=\"width:90%;\">".
		($action == "books" ? "<b>" : "<a href=\"".litres_plugin_url()."&action=books\" >")."Книги</a></b>".
		"&nbsp;&nbsp;&nbsp;&nbsp;".
		($action == "template" ? "<b>" : "<a href=\"".litres_plugin_url()."&action=template\">")."Шаблон</a></b>".
		"&nbsp;&nbsp;&nbsp;&nbsp;".
		($action == "settings" ? "<b>" : "<a href=\"".litres_plugin_url()."&action=settings\">")."Настройки</a></b>";


	if(true || $action == "books" || $action == "publish")
	{
		$search = "new";
		if(isset($_POST["search"]))
			$search = $_POST["search"];
		if(isset($_GET["search"]))
			$search = $_GET["search"];

		$nonpage = 25;
		if(isset($_POST["nonpage"]))
			$nonpage = $_POST["nonpage"]+0;
		if(isset($_GET["nonpage"]))
			$nonpage = $_GET["nonpage"]+0;
	


		echo "<span style=\"float:right;text-align:right;color:green;\">".
		($search == "publish" ? "<b style=\"color:green;\">" : "<a href=\"".litres_plugin_url()."&action=books&search=publish&nonpage=".$nonpage."\" style=\"color:green;\">")."Опубликованные</a></b></span>";

	}

	echo "</h3>";
	
}

function litres_plugin_wait_for_request() {
	$filename = plugin_dir_path( __FILE__ )."litres_request";
	if(file_exists($filename))
	{
		while(filemtime(plugin_dir_path( __FILE__ )."litres_request") >= time() - 2)
		{
			sleep(1);
		}
	}
	touch($filename);
}

if (!function_exists('mb_ucfirst')) {
    function mb_ucfirst($str, $encoding = "UTF-8", $lower_str_end = false) {
      $first_letter = mb_strtoupper(mb_substr($str, 0, 1, $encoding), $encoding);
      $str_end = "";
      if ($lower_str_end) {
        $str_end = mb_strtolower(mb_substr($str, 1, mb_strlen($str, $encoding), $encoding), $encoding);
      }
      else {
        $str_end = mb_substr($str, 1, mb_strlen($str, $encoding), $encoding);
      }
      $str = $first_letter . $str_end;
      return $str;
    }
  }

function litres_plugin_options_genres($genre,$genres,$indent,&$categories,&$ids,&$catOptions,&$cattext) {
		foreach($genres as $g)
		{
			if($g->name != "")
			{
				$title = "".mb_ucfirst($g->name);
				if(isset($g->sub) && count($g->sub) > 0)
				{
					$catOptions.="<optgroup label=\"".$indent.$title."\">";
					litres_plugin_options_genres($genre,$g->sub,$indent."&nbsp;&nbsp;&nbsp;&nbsp;",$categories,$ids,$catOptions,$cattext);
					$catOption.="</optgroup>";
				}
				else if(isset($g->id) && $g->id > 0)
				{
					$id = "".$g->id;
					$categories[$id] = $title;			
					$ids[$id] = $id;			
					if($genre == $id)
						$cattext = $title;

					$categories[$token] = $title;			
					$catOptions.="<option value=\"".$id."\" ".($genre."" == $id."" ? "selected" : "").">".$indent.$title."</option>";
				}
			}
		}

}

function litres_plugin_options_page1() {
	global $litres_plugin_ajaxurl;

	$debug = "";
	if(isset($_POST["debug"]))
		$debug = $_POST["debug"]."";
	if(isset($_GET["debug"]))
		$debug = $_GET["debug"]."";
	

	if($debug)
	{
		ini_set('display_errors', 1); 
		ini_set('display_startup_errors', 1); 
		error_reporting(E_ALL);
	}

	
	$search = "new";
	if(isset($_POST["search"]))
		$search = $_POST["search"];
	if(isset($_GET["search"]))
		$search = $_GET["search"];

	if($search == "Поиск")
		$search = "custom";

	litres_plugin_options_pageheader($search == "publish" ? "publish" : "books");

	
	$marked = array();
	if(isset($_POST["marked"]))
		$marked = $_POST["marked"];
	if(isset($_GET["marked"]))
		$marked = $_GET["marked"];
	$markaction = array();
	if(isset($_POST["markaction"]))
		$markaction = $_POST["markaction"];
	if(isset($_GET["markaction"]))
		$markaction = $_GET["markaction"];

	$order = "time_desc";
	if(isset($_POST["order"]))
		$order = $_POST["order"];
	if(isset($_GET["order"]))
		$order = $_GET["order"];

	
	$genre = "0";                      
	if(isset($_POST["genre"]))
		$genre = $_POST["genre"]."";
	if(isset($_GET["genre"]))
		$genre = $_GET["genre"]."";

	$sgenre = (trim($genre) != "0") ? "on" : "";


	
	$searchstring = "";
	if(isset($_POST["searchstring"]))
		$searchstring = $_POST["searchstring"];
	if(isset($_GET["searchstring"]))
		$searchstring = $_GET["searchstring"];

	$sstring = (trim($searchstring) != "") ? "on" : "";

	if($sstring)
		$sgenre = "";


	$offset = 0;
	if(isset($_POST["offset"]))
		$offset = $_POST["offset"]+0;
	if(isset($_GET["offset"]))
		$offset = $_GET["offset"]+0;
	
	$nonpage = 25;
	if(isset($_POST["nonpage"]))
		$nonpage = $_POST["nonpage"]+0;
	if(isset($_GET["nonpage"]))
		$nonpage = $_GET["nonpage"]+0;

	$jssorting = "";
	if(isset($_POST["jssorting"]))
		$jssorting = $_POST["jssorting"]."";
	if(isset($_GET["jssorting"]))
		$jssorting = $_GET["jssorting"]."";
	


	$gzcatfile = file_get_contents(plugin_dir_path( __FILE__ )."litres_genres_list_4");

	if(!$gzcatfile || filemtime(plugin_dir_path( __FILE__ )."litres_genres_list_4") <= time() - 60*60*24*10) //10days
	{
		litres_plugin_wait_for_request();
		
		$gzcatfile = litres_plugin_catalitv2("r_genres_list", array());
		file_put_contents(plugin_dir_path( __FILE__ )."litres_genres_list_4",$gzcatfile);
	}

	if($gzcatfile)

	{
		$categoriesRaw = json_decode($gzcatfile);


		$categories = array();
		$ids = array();

		$catOptions = "";

		$cattext = "";

	
		if($categoriesRaw->success && $categoriesRaw->r_genres_list && $categoriesRaw->r_genres_list->genres)
			litres_plugin_options_genres($genre,$categoriesRaw->r_genres_list->genres,"",$categories,$ids,$catOptions,$cattext);
			
	}

	echo "<form method=\"post\" action=\"".litres_plugin_url()."&action=books\"><input type=\"hidden\" name=\"page\" value=\"".plugin_basename(__FILE__)."\">".
		"<input type=\"hidden\" name=\"nonpage\" value=\"".$nonpage."\">".
		"<input type=\"hidden\" id=\"offset\" name=\"offset\" value=\"".$offset."\">".
		"<input type=\"hidden\" id=\"debug\" name=\"debug\" value=\"".$debug."\">".
		"<input type=\"hidden\" name=\"jssorting\" value=\"".$jssorting."\" id=\"jssorting\">";

	if($search != "publish")
	{
		echo "<div style=\"width:90%;border:solid 1px black;padding:10px;\"><table style=\"width:100%;\"><tr>".
			"<td><select style=\"margin-right:30px;\" name=\"genre\" id=\"genre\"><option value=\"0\">Выберите жанр</option>".$catOptions."</select></td><td width=\"80%\">".
			"<input type=\"text\" name=\"searchstring\" id=\"searchstring\" style=\"margin-right:30px;width:100%;\" placeholder=\"Название книг, автор\" value=\"".$searchstring."\"></td>".
			"<td><input type=\"hidden\" name=\"search\" value=\"".$search."\"><input type=\"submit\" value=\"Поиск\" name=\"search\" id=\"search\" onclick=\"jQuery('#offset').val(0);\"></td></tr></table></div>";

		echo "<p>Подборки книг: ".
			($search == "new" ? "<b>" : "<a href=\"".litres_plugin_url()."&action=books&search=new&nonpage=".$nonpage."\">")."Новое</a></b>".
			"&nbsp;&nbsp;&nbsp;&nbsp;".
			($search == "popular" ? "<b>" : "<a href=\"".litres_plugin_url()."&action=books&search=popular&nonpage=".$nonpage."\">")."Популярное</a></b>".
			/*
			"&nbsp;&nbsp;&nbsp;&nbsp;".
			($search == "interesting" ? "<b>" : "<a href=\"".litres_plugin_url()."&action=books&search=interesting&nonpage=".$nonpage."\">")."Интересное</a></b>"
			*/
			"</p>";
	}



	$searchcommand = false;
	$defgenre = 201583;

	if($search == "popular")
	{
		$searchcommand = "r_genre_arts_pop";
		$searchparams["genre"]=$genre ? $genre : $defgenre; 
	}
	
	if($search == "custom")
	{
		if($sgenre == "on")
		{	
			$searchcommand = "r_genre_arts_new";
			$searchparams["genre"]=$genre; 
		}
		if($sstring == "on" && strlen($searchstring) > 1)
		{	
			$searchcommand = "r_search_arts";
			$searchparams["q"]=$searchstring; 
		}
	}

	$searchparams["limit"]=array($offset+0,$nonpage+0); 
	if($search == "publish")
	{
		$searchids = array();
		$cnt++;
		foreach($mybooks as $myid=>$book)
		{
				if($cnt >= $offset && $cnt<$offset+$nonpage)
				$searchids[count($searchids)] = $myid;
		}
		if(count($searchids) == 0)
				$searchids[0]= "0";
		
		$searchcommand = "r_browse_arts";
		$searchparams["ids"]=$searchids; 
		$searchparams["limit"]=array(0,$nonpage+0); 
	}

	if($search == "new" || !$searchcommand)
	{
		$searchcommand = "r_genre_arts_new";
		$searchparams["genre"]=$genre ? $genre : $defgenre; 
	}
	
	$searchparams["anno"]=true; 

	$searchurl = json_encode(array("command"=>$searchcommand,"params"=>$searchparams));
	$savedsearch = file_get_contents(plugin_dir_path( __FILE__ )."litres_search");

	

	if($searchcommand && !$savedsearch || $searchurl != $savedsearch)
	{                      	
		litres_plugin_wait_for_request();
		$resfile = litres_plugin_catalitv2($searchcommand, $searchparams);
		file_put_contents(plugin_dir_path( __FILE__ )."searchresult.json",$resfile);
		file_put_contents(plugin_dir_path( __FILE__ )."litres_search",$searchurl);
	}
	else
	{
		$resfile = file_get_contents(plugin_dir_path( __FILE__ )."searchresult.json");
	}
	if(!$resfile)
		$resfile = "{}";
	if ( ! session_id() ) @ session_start();
	$_SESSION["lastsearch"] = $resfile;
	$resultsRaw = json_decode($resfile);
	if($resultsRaw && isset($resultsRaw->success) && $resultsRaw->success && isset($resultsRaw->{"".$searchcommand}) && isset($resultsRaw->{"".$searchcommand}->arts))
		$resultsRaw = $resultsRaw->{"".$searchcommand}->arts;
	else
		$resultsRaw = array();

	$resultsNum = 0;
	if($resultsRaw)
		$resultsNum = count($resultsRaw) + 0;
	

	$ajax = false;

	$mybooks = array();
	if(file_exists(plugin_dir_path( __FILE__ )."litres_mybooks") && filesize(plugin_dir_path( __FILE__ )."litres_mybooks") > 64*1024*1024)
		rename(plugin_dir_path( __FILE__ )."litres_mybooks",plugin_dir_path( __FILE__ )."litres_mybooks".date("Ymd"));

	if(file_exists(plugin_dir_path( __FILE__ )."litres_mybooks"))
		$mybooks = json_decode(file_get_contents(plugin_dir_path( __FILE__ )."litres_mybooks"));

	if(count($marked) > 0 && (isset($_GET['save']) || isset($_POST['save'])))
	{
		$newbooks = array();
		$delbooks = array();
		foreach($mybooks as $myid=>$book)
		{
			$mymarked = false;
			foreach($marked as $mid)
			{
				if($myid == $mid)
					$mymarked = true;
			}
			if(!$mymarked)
				$newbooks[$myid] = $book;
			if($mymarked)
				$delbooks[$myid] = $book;

		}
	
		if($markaction == "publish" && !$ajax && $resultsRaw)
		{
			foreach($resultsRaw as $jbook)
			{
				$book = new stdClass();
				$newid = $jbook->id."";
				$book->id = $newid;
				$book->book_id = $newid;


				foreach($marked as $m)
				{					
					if($m === $newid)
					{
						echo "<!-- ".$m." - ".$newid." --> ";

						$book->book_title = $jbook->title."";

						$authors = array();
						for($i=0;$i<count($jbook->persons);$i++)
							$authors[$i] = $jbook->persons[$i]->full_name;
				
						$book->authors = implode(", ",$authors);
						$book->annotation = $jbook->annotation;

						$genres = array();
						for($i=0;$i<count($jbook->genres);$i++)
							if(!isset($jbook->genres[$i]->is_tag) || !$jbook->genres[$i]->is_tag)
								$genres[$i] = $jbook->genres[$i]->name."";
		        		$book->genres = implode(", ", $genres);

						$book->price = $jbook->base_price." руб.";

						$tags = array();
						for($i=0;$i<count($jbook->genres);$i++)
							if(isset($jbook->genres[$i]->is_tag) && $jbook->genres[$i]->is_tag)
								$tags[$i] = $jbook->genres[$i]->name."";
						$book->tags = implode(", ", $tags);

						$ten = ($newid % 100); //43
						$ten = ($ten - $ten % 10) / 10; //(43 - 3) / 10 = 4)
						$ten = $ten % 10;
						$book->book_minicover_url = "https://cv".$ten.".litres.ru/pub/c/cover_200/".$newid.".jpg";
						$book->book_cover_url = "https://cv".$ten.".litres.ru/pub/c/cover/".$newid.".jpg";

						$sequences = array();
						for($i=0;$i<count($jbook->sequences);$i++)
							$sequences[$i] = $jbook->sequences[$i]->name."";
						$book->sequences = implode(", ",$sequences);

						$book->page_id = litres_plugin_add_book_page($book);
						$newbooks[$newid] = $book;
					}
				}
			}
		}

		if($markaction == "delete")         
		{
			
			foreach($delbooks as $delid=>$book)
			{
				litres_plugin_del_book_page($book);
			}

		}
	
		if($markaction != "none")
		{
			file_put_contents(plugin_dir_path( __FILE__ )."litres_mybooks",json_encode($newbooks));
			$mybooks = $newbooks;
		}
	}

	if($resultsNum > 0) 
	{
	
		echo "<table style=\"width:90%;margin-top:30px;\" id=\"litres_table\">";

		echo "<tr><td><input type=\"checkbox\" class=\"checkAll\"></td><td colspan=\"3\" style=\"width:50%;\">".
			"<a id=\"a_title\" href=\"javascript:litres_plugin_table_sort(event,'title');\">Название книги</a><span id=\"indicator_title\"></span></td>".
			"<td><a id=\"a_author\" href=\"javascript:litres_plugin_table_sort(event,'author');\">Автор</a><span id=\"indicator_author\"></span></td>".
			"<td><a id=\"a_genre\" href=\"javascript:litres_plugin_table_sort(event,'genre');\">Жанр</a><span id=\"indicator_genre\"></span></td>".
			"<td width=\"100px\"><a id=\"a_price\" href=\"javascript:litres_plugin_table_sort(event,'price');\">Цена</a><span id=\"indicator_price\"></span></td>".
			"<td><a id=\"a_date\" href=\"javascript:litres_plugin_table_sort(event,'date');\" style=\"white-space:nowrap;\">Год</a><span id=\"indicator_date\"></span></td>".
			"<td><a id=\"a_rating\" href=\"javascript:litres_plugin_table_sort(event,'rating');\">Рейтинг</a><span id=\"indicator_rating\"></span></td>".
			"<td><a id=\"a_status\" href=\"javascript:litres_plugin_table_sort(event,'status');\">Статус</a><span id=\"indicator_status\"></span></td></tr>";
		echo "<tr><td colspan=\"10\"><hr style=\"width:100%\"></td><tr>";


		$number = $offset;
		foreach($resultsRaw as $jbook)
		{

						$book->book_title = $jbook->title."";

						$authors = array();
						for($i=0;$i<count($jbook->persons);$i++)
							$authors[$i] = $jbook->persons[$i]->full_name;
				
						$book->authors = implode(", ",$authors);
						$book->annotation = $jbook->annotation;

						$genres = array();
						for($i=0;$i<count($jbook->genres);$i++)
							if(!isset($jbook->genres[$i]->is_tag) || !$jbook->genres[$i]->is_tag)
								$genres[$i] = $jbook->genres[$i]->name."";
		        		$book->genres = implode(", ", $genres);

						$book->price = $jbook->base_price." руб.";

						$tags = array();
						for($i=0;$i<count($jbook->genres);$i++)
							if(isset($jbook->genres[$i]->is_tag) && $jbook->genres[$i]->is_tag)
								$tags[$i] = $jbook->genres[$i]->name."";
						$book->tags = implode(", ", $tags);

						$ten = ($newid % 100); //43
						$ten = ($ten - $ten % 10) / 10; //(43 - 3) / 10 = 4)
						$ten = $ten % 10;
						$book->book_minicover_url = "https://cv".$ten.".litres.ru/pub/c/cover_200/".$newid.".jpg";
						$book->book_cover_url = "https://cv".$ten.".litres.ru/pub/c/cover/".$newid.".jpg";

						$sequences = array();
						for($i=0;$i<count($jbook->sequences);$i++)
							$sequences[$i] = $jbook->sequences[$i]->name."";
						$book->sequences = implode(", ",$sequences);


			$number++;
			$title = $jbook->title."";
			$authors = array();
			for($i=0;$i<count($jbook->persons);$i++)
				$authors[$i] = $jbook->persons[$i]->full_name;
			$author = $authors[0];

			$tstrings = explode(' ',mb_strtolower($searchstring,'utf-8'));
			foreach($authors as $authorstr)
			{
				$found = false;
				$bstrings = explode(' ',mb_strtolower($authorstr,'utf-8'));
				foreach($bstrings as $bstr)
				{
					foreach($tstrings as $tstr)
					{
						if(str_replace($tstr,"",$bstr) != $bstr)
							$found = true;
					}	
				}
				if($found)
					$author = $authorstr;
			}


			$genres = array();
			for($i=0;$i<count($jbook->genres);$i++)
				if(!isset($jbook->genres[$i]->is_tag) || !$jbook->genres[$i]->is_tag)
					$genres[$i] = array("id"=>$jbook->genres[$i]->id."","name"=>$jbook->genres[$i]->name."");
			
	        $category = $genres[0]["name"];
	        $catid = $genres[0]["id"];
			if($sgenre == "on")
			{	
				$catid = $genre;
				$category = $cattext;
			}

			$rawprice = $jbook->base_price."";
			$price = $rawprice." руб.";

			$sdate = $jbook->year_written."";
			$odate = $sdate;

			$rate = $jbook->ll_avg_marks.""+0;
			$id = $jbook->id."";

			$ten = ($id % 100); //43
			$ten = ($ten - $ten % 10) / 10; //(43 - 3) / 10 = 4)
			$ten = $ten % 10;
			$cover = "https://cv".$ten.".litres.ru/pub/c/cover_200/".$id.".jpg";

			$published = false;
			foreach($mybooks as $myid => $book)
			{
				if($myid == $id)
					$published = true;
			}

			$rating = "Низкий";
			if($rate >= 3)
				$rating = "Средний";
			if($rate > 4.2)
				$rating = "Высокий";
			$rating = "<span style=\"display:none;\">".$rate."</span>".$rating;
			
			echo "<tr id=\"litres_".$id."\"><td><input type=\"checkbox\" class=\"cb-element\" name=\"marked[]\" value=\"".$id."\"></td>".
				"<td><span class=\"number\">".$number."</span></td><td>".
				"<a href=\"//www.litres.ru/".$id."/\" target=\"_blank\"><img style=\"height:60px;\" src=\"".$cover."\" alt=\"".$title."\"/></a></td>".
				"<td width=\"50%\"><a href=\"//www.litres.ru/".$id."/\" target=\"_blank\">".$title."</a></td>".
				"<td><a style=\"color:#444;text-decoration:none;\" href=\"javascript:litres_plugin_searchauthor('".$author."');\">".$author."</a></td>".
				"<td><a style=\"color:#444;text-decoration:none;\" href=\"javascript:litres_plugin_searchgenre('".$catid."');\">".$category."</a></td>".
				"<td style=\"white-space:nowrap;\">".$price."</td><td>".$odate."</td><td>".$rating."</td>".
				"<td>".($published ? "<span style=\"color:green;\">Опубликовано</span>" : "")."</td></tr>";

			$title = str_replace("'","\'",$title);
			$author = str_replace("'","\'",$author);
			$category = str_replace("'","\'",$category);
			$script.="litres_plugin_add_table_row({'id':".$id.",'title':'".$title."','author':'".$author."','genre':'".$category."','price':".$rawprice.",'date':'".$sdate."','rating':".$rate.",'status':".($published ? 0 : 1)."});";
		}

	
		echo "<tr id=\"litres_end\"><td colspan=\"10\"><hr style=\"width:100%\"></td></tr></table>";

		if(!$litres_plugin_ajaxurl)
			$litres_plugin_ajaxurl = "";

		echo "<script type=\"text/javascript\">jQuery(document).ready(function($){".$script."});".$litres_plugin_ajaxurl."</script>";

		$purl = litres_plugin_url()."&action=books&search=".$search."&genre=".$genre."&searchstring=".$searchstring."&jssorting=".$jssorting;

		if($resultsNum > $nonpage-1)
        	$resultsNum = 9999999;
		$curpage = ($offset - $offset%$nonpage) / $nonpage + 1;
		$numpage = ($resultsNum - $resultsNum%$nonpage) / $nonpage + ($resultsNum%$nonpage == 0 ? 0 : 1);
		$pages = "";
	
		for($page=1;$page<=$numpage;$page++)
		{
			if($page <= 3 || $page >= $numpage - 3 || abs($page - $curpage) <= 3)
			{
				if($lpage + 1 != $page)
					$pages.="...&nbsp;&nbsp;";
				$poff = ($page - 1)*$nonpage;
				$pages.=($curpage == $page ? "<b>" : "<a href=\"".$purl."&offset=".$poff."&nonpage=".$nonpage."\">").			
				$page.($curpage == $page ? "</b>" : "</a>")."&nbsp;&nbsp;";
				$lpage = $page;
			}
		}

		echo "<table style=\"width:90%\"><tr><td style=\"text-align:left;\">Книг на странице:&nbsp;&nbsp;".
			($nonpage+0 != 10 ? "<a href=\"".$purl."&nonpage=10\" class=\"purl\">10</a>" : "<b>10</b>")."&nbsp;&nbsp;&nbsp;".
			($nonpage+0 != 25 ? "<a href=\"".$purl."&nonpage=25\" class=\"purl\">25</a>" : "<b>25</b>")."&nbsp;&nbsp;&nbsp;".
			($nonpage+0 != 50 ? "<a href=\"".$purl."&nonpage=50\" class=\"purl\">50</a>" : "<b>50</b>")."&nbsp;&nbsp;&nbsp;".
			($nonpage+0 != 100 ? "<a href=\"".$purl."&nonpage=100\" class=\"purl\">100</a>" : "<b>100</b>").
			"</td><td style=\"text-align:right;\">".($offset > 0 && $offset+$nonpage < $resultsNum ? "Страница:&nbsp;&nbsp;" : "").
			($offset > 0 ? "<a href=\"".$purl."&offset=".($offset-$nonpage)."&nonpage=".$nonpage."\" class=\"purl\">&larr; Назад</a>" : "").
			($offset > 0 && $offset+$nonpage < $resultsNum ? "&nbsp;&nbsp;&brvbar;&nbsp;&nbsp;" : "").
			($offset+$nonpage < $resultsNum ? "<a href=\"".$purl."&offset=".($offset+$nonpage)."&nonpage=".$nonpage."\" class=\"purl\">Вперед &rarr;</a>" : "").
			"</td></tr></table>";
	

		echo "<p>Выделенное: </p>";
		echo "<input type=\"hidden\" id=\"jsoffset\" value=\"".$offset."\"/>";

		$wpcategories = litres_plugin_categories_select();

		echo "<p><select style=\"margin-right:20px;\" name=\"markaction\"  id=\"markaction\" onchange=\"document.getElementById('catsel').style.display=(this.options[this.selectedIndex].value == 'publish' ? 'inline-block' : 'none');\">".
			 "<option value=\"none\" selected>Действие</option><option value=\"publish\">Опубликовать</option><option value=\"delete\">Удалить</option></select>".
			 "<span style=\"display:none;\" id=\"catsel\">&nbsp;&nbsp;В рубрику: <select name=\"category\" id=\"category\">".$wpcategories."</select>&nbsp;&nbsp;</span>".
			 "<input type=\"submit\" name=\"save\" value=\"Выполнить\" onclick=\"return litres_plugin_trypublish(event);\">";

	}
	else
	{
		if($search == "publish")
			echo "<p>Нет опубликованных книг</p>";	
		else
			echo "<p>Книги не найдены</p>";	
	}
	echo "</form>";

	$lrkey = "";
	if(file_exists(plugin_dir_path( __FILE__ )."litres_key"))
		$lrkey = file_get_contents(plugin_dir_path( __FILE__ )."litres_key");

	echo "<script type=\"text/javascript\">jQuery(document).ready(function($) {";

	echo "litres_plugin_jssorting = '".$jssorting."';";
	echo "litres_plugin_lfrom = '".$lrkey."';";
	echo "litres_plugin_startcount = ".$offset.";";
	echo "litres_plugin_sortinit(litres_plugin_jssorting);";

	echo "});</script>";

	echo "<div id=\"test\"></div>";
	
}

$litres_plugin_categories = "";

function litres_plugin_options_page2() {
	global $litres_plugin_categories;

	litres_plugin_options_pageheader("template");

	$title = "\$book_title";
	$template = "<h2>\$authors</h2>\n".
	"<img src=\"\$book_cover_url\" title=\"\$book_title\" alt=\"\$book_title\"/>\n<p>\$annotation</p>\n<p>".
	"\$price&nbsp;<a href=\"\$sample_url\">Читать фрагмент</a>&nbsp;<a href=\"\$purchase_url\">Купить книгу</a></p>";
	$tags = "\$genres, \$tags, \$sequences";

	echo "<table style=\"width:90%;\"><tr><td width=\"65%\">";


	if(file_exists(plugin_dir_path( __FILE__ )."litres_title"))
		$title = file_get_contents(plugin_dir_path( __FILE__ )."litres_title");
	if(file_exists(plugin_dir_path( __FILE__ )."litres_template"))
		$template = file_get_contents(plugin_dir_path( __FILE__ )."litres_template");
	if(file_exists(plugin_dir_path( __FILE__ )."litres_tags"))
		$tags = file_get_contents(plugin_dir_path( __FILE__ )."litres_tags");


	if(isset($_POST["submit"]) && $_POST["submit"]=="true")
	{
		$title = str_replace("\\\"","\"",$_POST["title"]);
		file_put_contents(plugin_dir_path( __FILE__ )."litres_title", $title);
		$template = str_replace("\\\"","\"",$_POST["template"]);
		file_put_contents(plugin_dir_path( __FILE__ )."litres_template", $template);
		$tags = str_replace("\\\"","\"",$_POST["tags"]);
		file_put_contents(plugin_dir_path( __FILE__ )."litres_tags", $tags);
		if(isset($_POST["category"]))
		{
			$category = str_replace("\\\"","\"",$_POST["category"]);
			file_put_contents(plugin_dir_path( __FILE__ )."litres_category", $category);
		}
	}

	echo "<form method=\"post\" action=\"".litres_plugin_url()."&action=template\"><input type=\"hidden\" name=\"submit\" value=\"true\"><input type=\"hidden\" name=\"page\" value=\"".plugin_basename(__FILE__)."\"><input type=\"hidden\" name=\"action\" value=\"template\">";
	echo "<p style=\"width:100%;\"><b>Заголовок:</b>";
	echo "<input type=\"text\" style=\"width:100%;box-sizing: border-box;-webkit-box-sizing:border-box;-moz-box-sizing:border-box;\" name=\"title\" id=\"title\" value=\"".$title."\" onfocus=\"litres_plugin_focus('title');\"></p>";

	echo "<p style=\"width:100%;\"><b>Публикация:</b>";
	echo "<textarea name=\"template\" id=\"template\" style=\"width:100%;height:360px;\" onfocus=\"litres_plugin_focus('template');\">".$template."</textarea></p>";
	
	echo "<script type=\"text/javascript\">".
		"if(litres_plugin_runCKEDITOR) litres_plugin_runCKEDITOR();".
		"</script>";

	echo $litres_plugin_categories;

	echo "<p style=\"width:100%;\"><b>Тэги:</b>";
	echo "<input type=\"text\" style=\"width:100%;box-sizing: border-box;-webkit-box-sizing:border-box;-moz-box-sizing:border-box;\" name=\"tags\" id=\"tags\" value=\"".$tags."\" onfocus=\"litres_plugin_focus('tags');\"></p>";


	if(isset($_POST["submit"]) && $_POST["submit"]=="true")
	{
		echo "<p style=\"color:green;\">Шаблон сохранен успешно.</p>";
	}


	echo "<p><input type=\"submit\" value=\"Сохранить\"></p></form>";

	echo "</td><td style=\"vertical-align:top;text-align:right;\">";

	echo "<div style=\"width:95%;border:solid 1px black;padding:10px;margin-top:19px;text-align:left;\">".
	"<b>Шаблоны подстановки:</b> <br/>Кликайте на подстановку, а не копируйте текст, некоторые подстановки составные.<br/> <br/>".
	"<a href=\"javascript:litres_plugin_insert('\$book_id');\">\$book_id</a> – Идентификатор книги <br/>".
	"<a href=\"javascript:litres_plugin_insert('\$authors');\">\$authors</a> – Имена, фамилии авторов <br/>".
	"<a href=\"javascript:litres_plugin_insert('\$book_title');\">\$book_title</a> – Название книги  <br/>".
	"<a href=\"javascript:litres_plugin_insert('\$annotation');\">\$annotation</a> – Описание книги  <br/>".
	"<a href='javascript:litres_plugin_insert(\"<img src=\\\"\$book_minicover_url\\\" title=\\\"\$book_title\\\" alt=\\\"\$book_title\\\"/>\");'>\$book_minicover</a> – Изображение обложки (мини) <br/>".
	"<a href='javascript:litres_plugin_insert(\"<img src=\\\"\$book_cover_url\\\" title=\\\"\$book_title\\\" alt=\\\"\$book_title\\\"/>\");'>\$book_cover</a> – Изображение обложки (полный размер) <br/>".
	"<a href='javascript:litres_plugin_insert(\"<a href=\\\"\$purchase_url\\\">Купить книгу</a>\");'>\$purchase_url</a> – Ссылка на покупку <br/>".
	"<a href='javascript:litres_plugin_insert(\"<a href=\\\"\$sample_url\\\">Читать фрагмент</a>\");'>\$sample_url</a> – Ссылка на чтение бесплатного фрагмента <br/>".
	"<a href=\"javascript:litres_plugin_insert('\$genres');\">\$genres</a> – Жанры книги <br/>".
	"<a href=\"javascript:litres_plugin_insert('\$price');\">\$price</a> – Стоимость книги  <br/>".
	"<a href=\"javascript:litres_plugin_insert('\$tags');\">\$tags</a> – Тэги книги <br/>".
	"<a href=\"javascript:litres_plugin_insert('\$sequences');\">\$sequences</a> – Серии книги <br/>".
	"</div>";

	echo "</td></tr><table>";
}

function litres_plugin_options_page3() {
	litres_plugin_options_pageheader("settings");

	$lrkey = "";
	if(file_exists(plugin_dir_path( __FILE__ )."litres_key"))
		$lrkey = file_get_contents(plugin_dir_path( __FILE__ )."litres_key");

	echo "<form method=\"post\" action=\"".litres_plugin_url()."&action=settings\"><input type=\"hidden\" name=\"submit\" value=\"true\"><input type=\"hidden\" name=\"page\" value=\"".plugin_basename(__FILE__)."\"><input type=\"hidden\" name=\"action\" value=\"settings\">";
	echo "<p>Подать заявку на участие в партнерской программе ЛитРес - <a href=\"//www.litres.ru/pages/reader_partner/\" target=\"_blank\">https://www.litres.ru/pages/reader_partner/</a></p>";
	if(isset($_POST["submit"]) && $_POST["submit"]=="true")
	{
		$newkey = str_replace("\\\"","\"",$_POST["key"]);
		if(trim($newkey) != "" && ($newkey+0)."" == $newkey)
		{
			$lrkey = $newkey;
			file_put_contents(plugin_dir_path( __FILE__ )."litres_key", $lrkey);
			echo "<p style=\"color:green;\">Настройки сохранены успешно.</p>";
		}
		else
		{
			echo "<p style=\"color:red;\"><b>'".$newkey."'</b> - Недопустимое значение ID партнера (lfrom). Должно быть только цифровое значение.</p>";
		}
			
	}
	echo "<p>ID партнера (lfrom) <input type=\"text\" name=\"key\" value=\"".$lrkey."\" placeholder=\"ID партнера (lfrom)\">&nbsp;&nbsp;<input type=\"submit\" value=\"Сохранить\"></p></form>";

}


?>
